#ifndef UTILS_INTERNAL_H_INCLUDED
#define UTILS_INTERNAL_H_INCLUDED

#include <QString>

namespace internal {

    static constexpr const char *UPDATE_NOT_NECESSARY{"not necessary"};
    static constexpr const char *UPDATE_NOT_REQUESTED{"not requested"};
    static constexpr const char *UPDATE_REQUESTED{"requested"};

    static constexpr const char *NO_CUSTOMER_REPOSITORY{"no customer repository"};
    static constexpr const int NO_CUSTOMER_REPOSITORY_CODE{-8};
    static constexpr const char *NO_ETC_CUSTOMER_REPOSITORY{"no etc/ in customer repository"};
    static constexpr const int NO_ETC_CUSTOMER_REPOSITORY_CODE{-9};
    static constexpr const char *NO_OPT_CUSTOMER_REPOSITORY{"no opt/ in customer repository"};
    static constexpr const int NO_OPT_CUSTOMER_REPOSITORY_CODE{-10};

    static constexpr const char *ISMAS_CONNECTED{"connected"};
    static constexpr const char *ISMAS_DISCONNECTED{"disconnected"};
    static constexpr const char *ISMAS_DISCONNECTING{"disconnecting"};
    static constexpr const char *ISMAS_NOT_CONNECTED{"not connected"};
    static constexpr const char *ISMAS_CONNECTION_IN_PROGRESS{"connecting"};

    static constexpr const int GIT_CHECKOUT_ERROR_CODE{-2};
    static constexpr const int GIT_PULL_ERROR_CODE{-4};
    static constexpr const int GIT_NOT_NECESSARY_CODE{1};
    static constexpr const int GIT_UPDATED_CODE{2};

    static constexpr const char *GIT_CUSTOMER_REPO_CHECKOUT_ERROR{"checkout error"};
    static constexpr const char *GIT_CUSTOMER_REPO_PULL_ERROR{"pull error"};
    static constexpr const char *GIT_CUSTOMER_REPO_UP_TO_DATE{"up to date"};
    static constexpr const char *GIT_CUSTOMER_REPO_NO_UPDATE_NECESSARY{"no repository update necessary"};
    static constexpr const char *GIT_CUSTOMER_REPO_NOT_NECESSARY{"not necessary"};
    static constexpr const char *GIT_CUSTOMER_REPO_UPDATED{"repository updated"};
    static constexpr const char *GIT_UPDATED{"updated"};

    static constexpr const char *EXEC_OPKG_COMMANDS_SUCCESS{"success"};
    static constexpr const char *EXEC_OPKG_COMMANDS_FAIL{"FAIL"};
    static constexpr const char *EXEC_OPKG_COMMANDS_NOACTION_SUCCESS{"success"};
    static constexpr const char *EXEC_OPKG_COMMANDS_NOACTION_FAIL{"FAIL"};

    static constexpr const char *UPDATE_DC_JSON_FILES_SUCCESS{"success"};

    static constexpr const char *SYNC_CUSTOMER_REPO_FILES_SUCCESS{"success"};

    static constexpr const char *UPDATE_DC_FIRMARE_SUCCESS{"success"};

    static constexpr const char *OPKG_MARKER{"<OPKG>"};
    static constexpr const char *SYNC_MARKER{"<SYNC>"};
    static constexpr const char *DC_MARKER{"<DC>"};
    static constexpr const char *GIT_MARKER{"<GIT>"};
    static constexpr const char *ISMAS_MARKER{"<ISMAS>"};

    static constexpr const int PERCENT_CHECK_ISMAS_CONNECIVITY{10};
    static constexpr const int PERCENT_CHECK_UPDATE_REQUEST{20};
    static constexpr const int PERCENT_CHECK_CUSTOMER_REPOSITORY{30};
    static constexpr const int PERCENT_INSTALL_SW_PACKETS_NOACTION{40};
    static constexpr const int PERCENT_INSTALL_SW_PACKETS{50};
    static constexpr const int PERCENT_INSTALL_DC_CONFIGURATION{60};
    static constexpr const int PERCENT_SYNCHRONIZE_REPO_AND_FILESYS{70};
    static constexpr const int PERCENT_UPDATE_DC{80};
    static constexpr const int PERCENT_SHOW_FINAL_STATUS{90};

    int read1stLineOfFile(QString fileName);
    QString customerRepoRoot();
    QString customerRepoDir();
    QString customerRepoDirName();
    QString repositoryUrl();
    QString branchName();
    bool customerRepoExists();
}

#endif // UTILS_INTERNAL_H_INCLUDED
